以下是一些常见的linux系统头文件：

1. **`stdio.h`** - 标准输入输出函数，如 `printf`、`scanf`、`fopen`、`fclose` 等。

2. **`stdlib.h`** - 标准库函数，如 `malloc`、`free`、`rand`、`exit` 等。

3. **`string.h`** - 字符串操作函数，如 `strcpy`、`strlen`、`strcat` 等。

4. **`errno.h`** - 定义错误码。

5. **`limits.h`** - 定义各种数据类型的最大值和最小值。

6. **`fcntl.h`** - 文件控制选项，用于文件描述符的操作。

7. **`sys/types.h`** - 包含数据类型定义，如 `size_t`、`off_t` 等。

8. **`sys/stat.h`** - 文件状态信息和文件控制操作。

9. **`sys/time.h`** - 时间相关的系统调用和结构。

10. **`sys/resource.h`** - 资源限制和优先级设置。

11. **`sys/wait.h`** - 进程等待和状态查询。

12. **`sys/ioctl.h`** - 设备控制操作。

13. **`sys/socket.h`** - 提供套接字接口。

14. **`netinet/in.h`** - 提供网络通信所需的数据结构和宏。

15. **`arpa/inet.h`** - 提供网络地址转换函数。

16. **`netdb.h`** - 网络数据库操作。

17. **`signal.h`** - 信号处理。

18. **`setjmp.h`** - 非局部跳转。

19. **`time.h`** - 时间和日期函数。

20. **`pthread.h`** - POSIX 线程库。

21. **`dlfcn.h`** - 动态链接函数。

22. **`dirent.h`** - 目录操作。

23. **`grp.h`** - 组数据库操作。

24. **`pwd.h`** - 密码数据库操作。

25. **`termios.h`** - 终端控制。

26. **`sys/mman.h`** - 内存管理。

27. **`sys/shm.h`** - 共享内存。

28. **`sys/ipc.h`** - 进程间通信。

29. **`sys/msg.h`** - 消息队列。

30. **`sys/sem.h`** - 信号量。

这些头文件为 C 语言程序提供了与操作系统交互的接口。不同的程序可能会根据需要包含不同的头文件。
